main()
{
self thread precache();
self thread onConnect();
}

precache()
{
precacheShader("hudStopwatch");
}

timer()
{
	self endon("intermission");
	self endon("disconnect");
	self endon("killed_player");
	
	self.finished = false;
	current = self.current;
	if(!isdefined(current)) current = 1000000;
	if(getcvar("w_debug") == "1")
		self iprintlnbold(current);
	self.runtime = 0;
	newscore = 0;
	x = 0;

	while( !self.finished )
	{
		self.runtime += 0.1;
		wait(0.1);
		x++;
		if(x == 10)
		{
		x = 0;
		newscore++;
		}
	}

	if(getcvar("w_debug") == "1")
		self iprintlnbold(self.runtime);

	if( self.runtime < current )
	{
		extra = self.runtime - newscore;
		
		if(getcvar("w_debug") == "1")
		self iprintlnbold("Overig: " + extra);
		
		if( extra >= 0.5 )
		{
			self.score = newscore + 1;
			if(getcvar("w_debug") == "1")
			self iprintlnbold("+1 PUNT. ( extra >= 0.5 ) ");
		}
		else
		{
			self.score = newscore;
		}

		if(isDefined(self.hud_playerscore)) self.hud_playerscore setValue(self.score);

		if(getcvar("w_debug") == "1")
			self iprintlnbold(self.score);
		self.current = self.runtime;
	}

	self thread clean();
}

onConnect()
{
	for(;;)
	{
		level waittill("connecting", player);

		player thread OnSpawn();
	}
}

OnSpawn()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");
		self thread clean();
		self thread start();
		self thread touching_start();
		self thread touching_finish();
		if(getcvar("wipeout_remove_smoke") == "1" || getcvar("wipeout_remove_nades") == "1" || getcvar("wipeout_remove_ammo") == "1" || getcvar("wipeout_remove_ammo_2nd") == "1")
			thread removeammo();
	}
}




clean()
{
	if(isdefined(self.timer)) self.timer destroy();
	self.finished = undefined;
}

touching_start()
{
	self endon("intermission");
	self endon("disconnect");
	self endon("killed_player");
	
	start = getent("start","targetname");

	for(;;)
	{
		start waittill("trigger");
		if(self istouching(start))
		{	
			self notify("startrunning");
		}
	}

}

touching_finish()
{
	self endon("intermission");
	self endon("disconnect");
	self endon("killed_player");
	
	finish = getent("finish","targetname");

	for(;;)
	{
		finish waittill("trigger");
		if(self istouching(finish))
		{
			self notify("YouFinished");
		}
	}

}

start()
{
	self endon("intermission");
	self endon("disconnect");
	self endon("killed_player");
	
	start = getent("start","targetname");
	finish = getent("finish","targetname");

	self.runprotection = false;

	for(;;)
	{
		self waittill("startrunning");
		self thread clean();
		self iprintlnbold("^1Start running^7.");
		self thread timer();
		self thread clock();

		self waittill("YouFinished");
		self.finished = true;
		self iprintlnbold("^1You have finished in ^7" + self.runtime + "^1s.");
	}
}

clock()
{			
		self.timer = newClientHudElem(self);
		self.timer.x = 6;
		self.timer.y = 76;
		self.timer.horzAlign = "left";
		self.timer.vertAlign = "top";
		self.timer SetClock(60*6, 60, "hudStopwatch", 48, 48);
}

removeammo()
{
	players = getentarray("player", "classname");

	for (i = 0; i<players.size; i++)
	{
		_p = players[i];

			if (_p getWeaponSlotWeapon("primary") != "none" && getcvar("wipeout_remove_ammo") == "1")
			{
				//iprintln("primary is: " + _p getWeaponSlotWeapon("primary"));
				_p setWeaponSlotAmmo("primary", 0);
				_p setWeaponSlotClipAmmo("primary", 0);
			}
			if (_p getWeaponSlotWeapon("primaryb") != "none" && getcvar("wipeout_remove_ammo_2nd") == "1")
			{
				//iprintln("primaryb is: " + _p getWeaponSlotWeapon("primaryb"));
				_p setWeaponSlotAmmo("primaryb", 0);
				_p setWeaponSlotClipAmmo("primaryb", 0);
			}

			if(getcvar("wipeout_remove_nades") == "1")
			{
			_p takeWeapon ("frag_grenade_american_mp");
			_p takeWeapon ("frag_grenade_british_mp");
			_p takeWeapon ("frag_grenade_russian_mp");
			_p takeWeapon ("frag_grenade_german_mp");
			}
			
			if(getcvar("wipeout_remove_smoke") == "1")
			{
			_p takeWeapon ("smoke_grenade_american_mp");
			_p takeWeapon ("smoke_grenade_british_mp");
			_p takeWeapon ("smoke_grenade_russian_mp");
			_p takeWeapon ("smoke_grenade_german_mp");
			}
	}
}

